#ifndef EXTRUDER_H
#define EXTRUDER_H
#define REPLY_LENGTH 20
#define SET_T 'T'         // set_temperature(int temp);
#define GET_T 't'         // get_temperature();
#define SET_BED_T 'B'     // set bed temperature(int temp);
#define GET_BED_T 'b'     // get bed temperature();
#define WAIT_T 'W'        // wait_for_temperature();
#define COOL 'C'          // set_cooler(byte e_speed);
#define PING 'P'          // Just acknowledge
#define SHUT 'X'          // Hard stop

class extruder
{
public:
   extruder();
   char* processCommand(char command[]);
   void manage();
private:
/* E temp stuff */
   int  targetTemperature;           
   int  currentTemperature;          
   void setTemperature(int t);
   int getTemperature();
   void controlTemperature();
   int internalTemperature();
   void waitForTemperature();
   void slowManage();
   int  manageCount; 
/* B temp stuff, identical just with "Bed" in it */
   int  targetBedTemperature; 
   int  currentBedTemperature; 
   void setBedTemperature(int t); 
   int getBedTemperature(); 
   void controlBedTemperature(); 
   int internalBedTemperature(); 
   void waitForBedTemperature(); 
   void slowBedManage(); 
   int  manageBedCount; 
/* common other stuff */
   void setCooler(byte e_speed); /* gotta test if this works with changing the fan voltage */
   char reply[REPLY_LENGTH];   /* For sending messages back */
   void shutdown(); 
   int  skipCount;   /* This is used to skip temperature reads to allow the MAX6675 enough time for a temperature conversion.  Kurt Bidstrup A.K.A Smurf   5/30/2010 */
/* not used stuff */
   int sampleTemperature(); /* not used at all - converted it within an alternate line for ad595 reading alone */ 
/* for alternate waitForTemperature function that is commented out at the end - this may discover an error but cant report it to host, so no much point - unless there is a path to report it to host through master */ 
   void temperatureError(); 
   byte wait_till_hot();   
   byte waitcount ;         
   int oldT, newT;        
};
#endif
